// Dynamic link library implementation of NeuroSolutions BackTDNNAxon component 

#include "NSDLL.h"

/********************************/
/* Backpropagation of component */

__declspec(dllexport) void performBackTDNNAxon(
	DLLData *instance,	// Pointer to instance data (may be NULL)
	DLLData *dualInstance,	// Pointer to the forward axons instance data (may be NULL)
	NSFloat	*error,	 	// Pointer to the current sensitivity vector
	int 	rows,		// Number of rows of PEs in the layer
	int 	cols,		// Number of columns of PEs in the layer
	NSFloat	*delayedError, 	// Pointer to the error vector delayed by a user defined time step
	int 	taps,		// Number of memory taps specified by the user in the inspector
	NSFloat	*data	 	// Pointer to the layers of processing elements (PEs)
	)
{
	register int i,j,k,length=rows*cols;

	for (i=0; i<length; i++)
		for (j=1; j<taps; j++) {
			k = i + j*length;
			error[k-length] += delayedError[k];
		}
}

/******************************************/
/* Management of instance data (OPTIONAL) */
/*
__declspec(dllexport) DLLData *allocBackTDNNAxon(
	DLLData	*oldInstance,	// Pointer to the last instance if reallocating
	DLLData	*dualInstance,	// Pointer to forward axons instance data (may be NULL)
	int 	rows,		// Number of rows of PEs in the layer
	int 	cols,		// Number of columns of PEs in the layer
	int 	taps		// Number of taps attached to each PE
	)
{
	DLLData *instance = allocDLLInstance(oldInstance);
	return instance;
}

__declspec(dllexport) void freeBackTDNNAxon(DLLData *instance)
{
	freeDLLInstance(instance);
}
*/